src/main/java/com/br/mvsistemas/sysvendas/model/Empresa.java
package com.br.mvsistemas.sysvendas.model;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;

import org.hibernate.annotations.ForeignKey;
import org.hibernate.validator.constraints.NotEmpty;
import org.hibernate.validator.constraints.br.CNPJ;


@Entity
@Table(name = "empresa")
public class Empresa implements Entidade{

	/**
	 * 
	 */
	private static final long serialVersionUID = -1456649005878423512L;
	
	
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "id_empresa")
	private Long id;
	
	@Column(name = "razao_social")
	private String razaoSocial;
	
	@Column(name = "nome_fantasia")
	private String nomeFantasia;
	
	@CNPJ
	private String cnpj;
	
	private String ie;
	
	@ManyToOne @ForeignKey(name="fk_empresa_endereco")
	@JoinColumn(name = "id_endereco", nullable = true)
	private Endereco endereco = new Endereco();
	
	@OneToMany(fetch = FetchType.EAGER,cascade = CascadeType.ALL) 
	@JoinTable(name = "empresa_telefone", joinColumns = @JoinColumn(name = "id_empresa"), inverseJoinColumns = @JoinColumn(name = "id_telefone"))
	private Set<Telefone> telefones;
	
	@Enumerated(EnumType.STRING)
	@Column(name = "tipo_empresa", nullable = false)
	private TipoEmpresaEnum tipo;
	
	@Pattern(regexp="[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?", message="invalido ou campo em branco")
	private String email;

	@Override
	public Long getId() {
		return id;
	}

	@Override
	public void setId(Long id) {
		this.id = id;
	}
	
	public String getRazaoSocial() {
		return razaoSocial;
	}

	public void setRazaoSocial(String razaoSocial) {
		this.razaoSocial = razaoSocial;
	}

	public String getNomeFantasia() {
		return nomeFantasia;
	}

	public void setNomeFantasia(String nomeFantasia) {
		this.nomeFantasia = nomeFantasia;
	}

	public String getCnpj() {
		return cnpj;
	}

	public void setCnpj(String cnpj) {
		this.cnpj = cnpj;
	}

	public String getIe() {
		return ie;
	}

	public void setIe(String ie) {
		this.ie = ie;
	}

	public Endereco getEndereco() {
		return endereco;
	}

	public void setEndereco(Endereco endereco) {
		this.endereco = endereco;
	}

	public Set<Telefone> getTelefones() {
		return telefones;
	}

	public void setTelefones(Set<Telefone> telefones) {
		this.telefones = telefones;
	}

	public TipoEmpresaEnum getTipo() {
		return tipo;
	}

	public void setTipo(TipoEmpresaEnum tipo) {
		this.tipo = tipo;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((id == null) ? 0 : id.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Empresa other = (Empresa) obj;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		return true;
	}
	
}

src/main/java/com/br/mvsistemas/sysvendas/controller/EmpresaController.java
package com.br.mvsistemas.sysvendas.controller;

import java.io.IOException;
import java.io.Serializable;
import java.util.List;
import java.util.Set;

import javax.annotation.PostConstruct;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ActionListener;
import javax.faces.view.ViewScoped;
import javax.inject.Inject;
import javax.inject.Named;
import javax.validation.ConstraintViolation;
import javax.validation.Validation;
import javax.validation.Validator;

import org.json.simple.parser.ParseException;

import com.br.mvsistemas.sysvendas.dto.EmpresaDTO;
import com.br.mvsistemas.sysvendas.model.Cidades;
import com.br.mvsistemas.sysvendas.model.Empresa;
import com.br.mvsistemas.sysvendas.model.Telefone;
import com.br.mvsistemas.sysvendas.model.TipoEmpresaEnum;
import com.br.mvsistemas.sysvendas.service.CidadeService;
import com.br.mvsistemas.sysvendas.service.EmpresaService;
import com.br.mvsistemas.sysvendas.service.EnderecoService;
import com.br.mvsistemas.sysvendas.util.FacesMessages;


@Named
@ViewScoped
public class EmpresaController implements Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = -1188093964678532128L;
	
	
	private Empresa empresa;
	private Empresa empresaSelecionada;
	private Telefone telefone;
	private Telefone telefoneSelecionado;
	private List<Empresa> listaEmpresas;
	private boolean ativo = false;
	private List<Cidades> listaDeCidades;
	private EmpresaDTO pesquisaEmpresa;
	
	@Inject
	private CidadeService cidadeService;
	
	@Inject
	private EmpresaService empresaService;
	
	@Inject
	private EnderecoService enderecoService;
	
	@Inject
	private FacesMessages mensage;
		
	@PostConstruct
	public void consultar(){
		pesquisaEmpresa = new EmpresaDTO();
		empresa = new Empresa();
		telefone = new Telefone();
		//listaEmpresas = empresaService.listaEmpresas();
	}
	
	public void salvar(){
		
//		Validator validator = Validation.buildDefaultValidatorFactory().getValidator();
//        Set<ConstraintViolation<Empresa>> errors = validator.validate(this.empresa);
//
//        for (ConstraintViolation<Empresa> error : errors) {
//           mensage.error(error.getMessage());
//        }
//
//        if(!errors.isEmpty()){
//            return; 
//        }
		
		if (empresaService.salvar(empresa)) {
			consultar();
			desativar();
		}
	}
	
	public List<Cidades> listarCidades(String query) {
		return cidadeService.todasCidades(query, listaDeCidades, mensage);
	}
	
	public void buscarEndereco(){
		enderecoService.preencherEndereco(null, empresa, empresa.getEndereco());
	}
	
	public void buscarPorCnpj() {
		try {
			empresa = empresaService.buscaCnpj(empresa.getCnpj().replaceAll("\\D", ""));
		} catch (IOException | ParseException e) {
			if (e.getMessage().startsWith("504")) {
				mensage.error("Tempo Esgotado, CNPJ não encontrado na Base de Dados");
			}
			//e.printStackTrace();
		}
	}
	
	public void consultarEmpresas() {
		List<Empresa> emp = empresaService.consultaDeEmpresa(pesquisaEmpresa.getFantasia(), pesquisaEmpresa.getRazao(), 
				pesquisaEmpresa.getCnpj(), pesquisaEmpresa.getIe());
		if (emp.size() <= 0) {
			mensage.alert("Nenhuma Empresa encontrada...");
			listaEmpresas = null;
			return;
		} else {
			listaEmpresas = emp;
		}
	}
	
	public void excluir(ActionEvent actionEvent){
		empresaSelecionada = (Empresa) actionEvent.getComponent().getAttributes().get("empresaExcluida");
		try {
			empresaService.excluir(empresaSelecionada);
			consultarEmpresas();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public void editar(ActionEvent actionEvent){
		empresa = (Empresa) actionEvent.getComponent().getAttributes().get("empresaEditada");
		ativar();
		//FacesContext.getCurrentInstance().getExternalContext().getSessionMap().put("usuarioEditado", usuarioEdicao);
	}
	
	public void addTel() {
		enderecoService.adicionarTelefone(null, empresa, telefone);
	}
	
	public void delTel() {
		enderecoService.removerTelefone(null, empresa, telefoneSelecionado);
	}
	
	public void ativar(){
		ativo = true;
	}
	
	public void desativar(){
		ativo = false;
		empresa = new Empresa();
	}
	
	public List<Empresa> getListaEmpresas() {
		return listaEmpresas;
	}
	
	public Empresa getEmpresa() {
		return empresa;
	}

	public void setEmpresa(Empresa empresa) {
		this.empresa = empresa;
	}
	
	public Empresa getEmpresaSelecionada() {
		return empresaSelecionada;
	}
	
	public void setEmpresaSelecionada(Empresa empresaSelecionada) {
		this.empresaSelecionada = empresaSelecionada;
	}
	
	public TipoEmpresaEnum[] getTiposEmpresas(){
		return TipoEmpresaEnum.values();
	}
	
	public boolean isAtivo() {
		return ativo;
	}
	
	public List<Cidades> getListaDeCidades() {
		return listaDeCidades;
	}

	public Telefone getTelefone() {
		return telefone;
	}

	public void setTelefone(Telefone telefone) {
		this.telefone = telefone;
	}

	public Telefone getTelefoneSelecionado() {
		return telefoneSelecionado;
	}

	public void setTelefoneSelecionado(Telefone telefoneSelecionado) {
		this.telefoneSelecionado = telefoneSelecionado;
	}
	
	public EmpresaDTO getPesquisaEmpresa() {
		return pesquisaEmpresa;
	}
	
	public void setPesquisaEmpresa(EmpresaDTO pesquisaEmpresa) {
		this.pesquisaEmpresa = pesquisaEmpresa;
	}
}

src/main/webapp/empresa/index.xhtml
<ui:composition xmlns="http://www.w3.org/1999/xhtml"
    xmlns:h="http://java.sun.com/jsf/html"
    xmlns:f="http://java.sun.com/jsf/core"
	xmlns:ui="http://java.sun.com/jsf/facelets"
    xmlns:p="http://primefaces.org/ui"
    xmlns:fn="http://java.sun.com/jsp/jstl/functions">

	<h1>
		<small>Administração de Empresa</small>
	</h1>
	
	<p:tabView id="tbvEmpresas">
		
		<p:tab id="tbCadastro" title="Cadastro">
			<h:form id="form1" enctype="multipart/form-data">
				<p:panel>
					<p:toolbar id="tbOpcoes" style="margin-top: 20px">
					<p:toolbarGroup>
						<p:commandButton value="Salvar" id="botaoSalvar"
							action="#{empresaController.salvar}" styleClass="corVerde"
							update="form1 growl tbOpcoes"
							rendered="#{empresaController.ativo}"
							process="@this :tbvEmpresas:form1:panel-dialog panelEndereco" />
						<p:commandButton value="Novo" id="botaoNovo" styleClass="corAzul"
		    							 actionListener="#{empresaController.ativar}" 
		    							 rendered="#{!empresaController.ativo}"
		    							 update="tbOpcoes panel-dialog panel-telefones panelEndereco" process="@this"/>
		    							 
		    			<p:commandButton value="Cancelar" id="botaoCancelar" styleClass="corVermelho"
		    							 rendered="#{empresaController.ativo}"
		    							 actionListener="#{empresaController.desativar}"
		    							 update="tbOpcoes panel-dialog panel-telefones panelEndereco" process="@this">
		    				<p:resetInput target="panel-dialog" />
		    			</p:commandButton>
					</p:toolbarGroup>
				</p:toolbar>
				</p:panel>
				<h:outputText value="Dados da Empresa" style="font-weight: bold" />
				<p:separator title="Empresa" />

				<p:panelGrid columns="4" id="panel-dialog" style="padding-top: 10px;" styleClass="semBorda">
					
					<p:outputLabel value="Tipo" for="tipoEmpresa" />
					<p:selectOneMenu id="tipoEmpresa" value="#{empresaController.empresa.tipo}" disabled="#{!empresaController.ativo}">
						<f:selectItems value="#{empresaController.tiposEmpresas}" 
									   var="tipo" itemLabel="#{tipo.descricao}"
									   itemValue="${tipo}" />
					</p:selectOneMenu>
					
					<p:outputLabel value="CNPJ" for="cnpj"/>
                    <p:inputMask disabled="#{!empresaController.ativo}"
                    			mask="99.999.999/9999-99" value="#{empresaController.empresa.cnpj}" id="cnpj">
                    	<p:ajax event="change" update="panelEndereco panel-dialog panel-telefones growl" process="@this"
									listener="#{empresaController.buscarPorCnpj}" onstart="PF('Loading').show()" onsuccess="PF('Loading').hide()"/>
                    </p:inputMask>
                  
					<p:outputLabel value="Razão Social" for="razaoSocial" />
					<p:inputText id="razaoSocial" disabled="#{!empresaController.ativo}"
						value="${empresaController.empresa.razaoSocial}" size="50" onkeyup="caps(this)" onblur="caps(this)">
						<p:ajax event="blur" />
					</p:inputText>
					<p:outputLabel value="Nome Fantasia" for="nomeFantasia" />
					<p:inputText id="nomeFantasia" disabled="#{!empresaController.ativo}"
						value="${empresaController.empresa.nomeFantasia}" size="50" onkeyup="caps(this)" onblur="caps(this)">
						<p:ajax event="blur" />
					</p:inputText>
					
					<p:outputLabel value="E-mail" for="email" />
					<p:inputText disabled="#{!empresaController.ativo}"
								id="email" size="50" value="#{empresaController.empresa.email}"/>
				
				</p:panelGrid>

				<h:outputText value="Endereço" style="font-weight: bold" />
				<p:separator title="Endereço" />
				
				<!-- painel para adicionar endereco -->
				<p:panelGrid columns="4" id="panelEndereco" styleClass="semBorda">
					<p:outputLabel value="CEP" for="cep" />
					<p:inputMask mask="99999-999" id="cep"
						value="#{empresaController.empresa.endereco.cep}"
						style="width: 70px;" disabled="#{!empresaController.ativo}">
						<p:ajax event="change" update="panelEndereco growl" 
									listener="#{empresaController.buscarEndereco}" />
					</p:inputMask>

					<p:outputLabel value="Logradouro" for="logradouro" />
					<p:inputText id="logradouro"
						value="#{empresaController.empresa.endereco.logradouro}"
						style="width: 300px;" disabled="#{!empresaController.ativo}" onkeyup="caps(this)" onblur="caps(this)">
						<p:ajax event="blur" />
					</p:inputText>

					<p:outputLabel value="Número" for="numero" />
					<p:inputText id="numero"
						value="#{empresaController.empresa.endereco.numero}"
						style="width: 70px;" disabled="#{!empresaController.ativo}" onkeyup="caps(this)" onblur="caps(this)">
						<p:ajax event="blur" />
					</p:inputText>

					<p:outputLabel value="Complemento" for="complemento" />
					<p:inputText id="complemento"
						value="#{empresaController.empresa.endereco.complemento}"
						style="width: 300px;" disabled="#{!empresaController.ativo}" onkeyup="caps(this)" onblur="caps(this)">
						<p:ajax event="blur" />
					</p:inputText>

					<p:outputLabel value="Cidade" for="cidade" />
					<p:autoComplete id="cidade" disabled="#{!empresaController.ativo}"
						completeMethod="#{empresaController.listarCidades}"
						value="#{empresaController.empresa.endereco.cidade}" var="cidade"
						itemLabel="#{cidade.nome}" itemValue="#{cidade}"
						converter="genericConverter" forceSelection="true">
						<p:ajax event="itemSelect" update="panelEndereco"/>
					</p:autoComplete>

					<p:outputLabel value="Bairro" for="bairro" />
					<p:inputText id="bairro" disabled="#{!empresaController.ativo}"
						value="#{empresaController.empresa.endereco.bairro}" onkeyup="caps(this)" onblur="caps(this)">
						<p:ajax event="blur" />
					</p:inputText>

					<p:outputLabel value="Estado" for="uf" />
					<p:inputText id="uf" disabled="true" 
						value="#{empresaController.empresa.endereco.cidade.estado.uf}"
						maxlength="2" style="width: 40px; background-color: #3C8DBC;"/>
				</p:panelGrid>
				<!-- fim painel para adicionar endereco -->

				<h:outputText value="Telefones" style="font-weight: bold" />
				<p:separator title="Telefones" />
				
				<!-- painel para adicionar telefone -->
				<h:panelGrid columns="1" id="panel-telefones" width="300"
					style="padding-bottom: 10px;" >
					<p:commandButton value="Adicionar Telefone" styleClass="corAzul" style="width: 60%"
						process="@this" update="panelTelefone" disabled="#{!empresaController.ativo}"
						action="#{clienteController.novoTel}"
						oncomplete="PF('telefoneDialog').show()">
						<p:resetInput target="panelTelefone" />
					</p:commandButton>
					<p:dataTable value="${empresaController.empresa.telefones}" rows="3"
						paginatorAlwaysVisible="true" paginatorPosition="bottom" paginator="true"
						var="telefone" emptyMessage="Nenhum telefone foi adicionado" reflow="true">
						<p:column headerText="Número">
							<h:outputText value="#{telefone.numero}" />
						</p:column>

						<p:column headerText="Ação" width="60">
							<p:commandButton icon="ui-icon-trash" process="@this"
								update=":tbvEmpresas:form1:panel-telefones" id="excluir-fone-button"
								style="width: 45%" disabled="#{!empresaController.ativo}" action="#{empresaController.delTel}">
								<p:confirm header="Remover Telefone" icon="ui-i con-alert"
									message="Você tem certeza que deseja remover este telefone?" />
								<f:setPropertyActionListener value="#{telefone}"
									target="#{empresaController.telefoneSelecionado}" />
							</p:commandButton>
							<p:tooltip for="excluir-fone-button" value="Remover Telefone" />
						</p:column>
					</p:dataTable>
				</h:panelGrid>
				<!-- fim painel para adicionar telefone -->
				
				<!-- comeco dialogo telefone -->
				<p:dialog header="Telefone" widgetVar="telefoneDialog"
					id="dialog-telefone" resizable="false" closeOnEscape="true"
					responsive="true" modal="true">
					<h:panelGroup id="panelTelefone" layout="block"
						styleClass="ui-fluid">
<!-- 						<p:messages id="msgTelefone" autoUpdate="false" /> -->

						<h:panelGrid columns="2" styleClass="panelgrid-noborder">

							<p:outputLabel value="Número" for="numero-fone" />

							<p:inputMask id="numero-fone" mask="?(99) 99999-9999"
								value="#{empresaController.telefone.numero}" />
							
							<br/>
							<p:outputLabel />
							<p:outputLabel />
							<p:commandButton value="Inserir Telefone"  process="panelTelefone"
								update="panel-telefones panelTelefone growl"
								action="#{empresaController.addTel}" styleClass="corVerde"
								oncomplete="if(!args.validationFailed) PF('telefoneDialog').hide()" />

						</h:panelGrid>
					</h:panelGroup>
				</p:dialog>
				<!-- fim dialogo telefone -->
				
				<!-- começo dialogo de confirmação -->
				<p:confirmDialog header="Exclusão"
					message="Tem certeza que deseja excluir?"
					widgetVar="confirmacaoExclusao">
					<p:button value="Não"
						onclick="PF('confirmacaoExclusao').hide(); return false;" />
					<p:commandButton value="Sim"
						oncomplete="PF('confirmacaoExclusao').hide();" />
				</p:confirmDialog>
				<!-- fim dialogo de confirmação -->
			</h:form>
		</p:tab>
		
		<p:tab id="tabConsulta" title="Consultar">
			<h:form id="form" enctype="multipart/form-data">
    		<h1>Pesquisar</h1>
    		<br/>
    		<h:panelGrid  columns="4" id="panel-consulta" style="padding-top: 10px;">
    		
				<p:outputLabel value="Cnpj: "/>
				<p:inputMask mask="99.999.999/9999-99" value="#{empresaController.pesquisaEmpresa.cnpj}"/>
				
				<p:outputLabel value="Insc. Estadual: "/>
				<p:inputText value="#{empresaController.pesquisaEmpresa.ie}"/>
				
				<p:outputLabel value="Razão Social: "/>
				<p:inputText value="#{empresaController.pesquisaEmpresa.razao}" onkeyup="caps(this)" onblur="caps(this)">
					<p:ajax event="blur" />
				</p:inputText>
				
				<p:outputLabel value="Nome Fantasia: "/>
				<p:inputText value="#{empresaController.pesquisaEmpresa.fantasia}" onkeyup="caps(this)" onblur="caps(this)">
					<p:ajax event="blur" />
				</p:inputText>
				
			</h:panelGrid>
			
			<center><p:commandButton value="Buscar" id="buscar"
   							 actionListener="#{empresaController.consultarEmpresas}" 
   							 update=":tbvEmpresas:form:tblEmpresa growl" process="@this :tbvEmpresas:form:panel-consulta"/></center>
				    		    	
	    	<p:dataTable id="tblEmpresa" emptyMessage="Nenhuma Empresa" paginator="true" value="#{empresaController.listaEmpresas}"
	    			paginatorAlwaysVisible="true" paginatorPosition="bottom" style="margin-top: 20px" var="empresas" rows="4">
	    			    		
	    		<p:column headerText="Nome Fantasia: " >
	    			<h:outputText value="#{empresas.nomeFantasia}"/>
	    		</p:column>
	    		
	    		<p:column headerText="Razão Social: " >
	    			<h:outputText value="#{empresas.razaoSocial}"/>
	    		</p:column>
	    		
	    		<p:column headerText="Cnpj" >
	    			<h:outputText value="#{empresas.cnpj}"/>
	    		</p:column>
	    		
	    		<p:column headerText="Insc. Estadual">
	    			<h:outputText value="#{empresas.ie}"/>
	    		</p:column>
	    		
	    		<p:column headerText="Ações" width="90">
	    			<p:commandButton icon="ui-icon-pencil" title="Editar" onclick="tabView.select(0); return false;"
	    							actionListener="#{empresaController.editar}" update=":tbvEmpresas:form:tblEmpresa">
	  					<f:attribute name="empresaEditada" value="#{empresas}"/>
	    			</p:commandButton>
	    	
	    			<p:commandButton icon="ui-icon-trash" title="Excluir" actionListener="#{empresaController.excluir}" 
	    								update=":tbvEmpresas:form:tblEmpresa growl">
	  					<p:confirm header="Confirmar" message="Desenja excluir Empresa ?" icon="ui-icon-alert"/>
	  					<f:attribute name="empresaExcluida" value="#{empresas}"/>
	    			</p:commandButton>
	    		</p:column>
	    		<f:facet name="footer">
	                <h:outputText value="A Consuta resultou em:  " />
		                <h:outputText value="#{fn:length(empresaController.listaEmpresas) == null ? 0 : fn:length(empresaController.listaEmpresas)}" />
		                <h:outputText value=" Empresas cadastrados. " />
                </f:facet>
	    	</p:dataTable>
			<p:confirmDialog global="true">
				<p:commandButton value="Sim" type="button"
								styleClass="ui-confirmdialog-yes" icon="ui-icon-check" />
				<p:commandButton value="Nao" type="button" 
								styleClass="ui-confirmdialog-no" icon="ui-icon-close" />
			</p:confirmDialog>
			</h:form>
		</p:tab>
	</p:tabView>
</ui:composition>